###############################################
#
#  Improvements and feedbacks are welcome
#
#  This file is released under GPL >= 3
#
###############################################

cmake_minimum_required( VERSION 2.8 )


#### general package setup

project( tdeadmin )
set( VERSION R14.0.4 )


#### include essential cmake modules

include( FindPkgConfig          )
include( CheckFunctionExists    )
include( CheckSymbolExists      )
include( CheckIncludeFile       )
include( CheckLibraryExists     )
include( CheckCSourceCompiles   )
include( CheckCXXSourceCompiles )


#### include our cmake modules

set( CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/cmake/modules" )
include( TDEMacros )


##### setup install paths

include( TDESetupPaths )
tde_setup_paths( )


##### optional stuff ############################

option( WITH_ALL_OPTIONS "Enable all optional support" OFF )
option( WITH_GCC_VISIBILITY "Enable fvisibility and fvisibility-inlines-hidden" ${WITH_ALL_OPTIONS} )


##### user requested modules #####

option( BUILD_ALL             "Build all"             OFF          )
option( BUILD_DOC             "Build doc"             ${BUILD_ALL} )
option( BUILD_KCRON           "Build kcron"           ${BUILD_ALL} )
option( BUILD_KDAT            "Build kdat"            ${BUILD_ALL} )
option( BUILD_KNETWORKCONF    "Build knetworkconf"    ${BUILD_ALL} )
option( BUILD_KPACKAGE        "Build kpackage"        ${BUILD_ALL} )
option( BUILD_KSYSV           "Build ksysv"           ${BUILD_ALL} )
option( BUILD_KUSER           "Build kuser"           ${BUILD_ALL} )
option( BUILD_LILO_CONFIG     "Build lilo-config"     ${BUILD_ALL} )
option( BUILD_SECPOLICY       "Build secpolicy"       ${BUILD_ALL} )
option( BUILD_TDEFILE_PLUGINS "Build tdefile-plugins" ${BUILD_ALL} )


##### user defined options #######

set( KU_FIRSTUID         500        CACHE STRING "KUser - first user ID"                )
set( KU_FIRSTGID         500        CACHE STRING "KUser - first group ID"               )
set( KU_USERPRIVATEGROUP false      CACHE STRING "KUser - use private groups"           )
set( KU_HOMEDIR_PERM     0700       CACHE STRING "KUser - home directory permissions"   )
set( KU_HOMETEMPLATE     "/home/%U" CACHE STRING "KUser - default template for homedir" )
set( KU_MAILBOX_GID      0          CACHE STRING "KUser - mailbox gid"                  )
set( KU_MAILBOX_PERM     0660       CACHE STRING "KUser - mailbox permissions"          )


##### configure checks

include( ConfigureChecks.cmake )


###### global compiler settings

add_definitions( -DHAVE_CONFIG_H )

set( CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${TQT_CXX_FLAGS}" )
set( CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -Wl,--no-undefined" )
set( CMAKE_MODULE_LINKER_FLAGS "${CMAKE_MODULE_LINKER_FLAGS} -Wl,--no-undefined" )


##### @TDE_MODULE_NAME@  directories

tde_conditional_add_subdirectory( BUILD_DOC             doc             )
tde_conditional_add_subdirectory( BUILD_KCRON           kcron           )
tde_conditional_add_subdirectory( BUILD_KDAT            kdat            )
tde_conditional_add_subdirectory( BUILD_KNETWORKCONF    knetworkconf    )
tde_conditional_add_subdirectory( BUILD_KPACKAGE        kpackage        )
tde_conditional_add_subdirectory( BUILD_KSYSV           ksysv           )
tde_conditional_add_subdirectory( BUILD_KUSER           kuser           )
tde_conditional_add_subdirectory( BUILD_LILO_CONFIG     lilo-config     )
tde_conditional_add_subdirectory( BUILD_SECPOLICY       secpolicy       )
tde_conditional_add_subdirectory( BUILD_TDEFILE_PLUGINS tdefile-plugins )


##### write configure files

configure_file( config.h.cmake config.h @ONLY )
